#ifndef INC_GTVIEWPORT_H
#define INC_GTVIEWPORT_H

#include "gtmanager.h"

/************************************************************************\
*
* GtViewPort class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

/* Type of callback data */
typedef struct GtViewPortCD
{
	word cxpos,cypos;		// Child position
	word cxsize,cysize;	// Child size
	word xsize,ysize;
} GtViewPortCD;


class GtViewPort : public GtManager
{
public:
		/* Standard */
	GtViewPort(void);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
	char *GetClass(void) { return("GtViewPort"); }
	sbool IsSubClassOf(char *cn);
		/* Instance checks */
	sbool IsManager(void) { return(TRUE); }
		/* Child management */
	sbool AddChild(GtWidget *o,ulong pos);
		/* Child requests */
	void MoveSizeReq(GtWidget *o,word xp,word yp,word xs,word ys);
		/* Callbacks */
	void AddCB(ulong tag,GtCallB cb,GtUDPtr ud);
	void RemCB(ulong tag,GtCallB cb);
		/* Internal method */
	void SetPosSize(word xp,word yp,word xs,word ys);
protected:
		/* Instance variables */
	GtCBList chg;
	word cxp,cyp,cxs,cys;
};

extern GtViewPort *GtMkViewPort(char *n,GtManager *p,GtTag *tgs);
extern GtViewPort *GtMkViewPort(char *n,GtManager *p,ulong tag,...);

#endif /* INC_GTVIEWPORT_H */
