#include "gtall.h"

int QuitCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	((GtApp *)ud)->BreakLoop();
	return(GTCB_CONT);
}

int DoneCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	GtTextArea *txt;
	GtSIDoneCD *scd;
	int cols,rows;
	
	scd=(GtSIDoneCD *)cd;
	if(scd->why!=GTDW_MOUSE)
	{
		txt=(GtTextArea *)ud;
		txt->GetColsRows(&cols,&rows);
		txt->Scroll(TRUE);
		txt->PutStr(0,rows-1,scd->str,scd->len);
		((GtStrInput *)obj)->Activate();
	}
	return(GTCB_CONT);
}

int AttrBoldCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	GtToggleCD *tcd;
	GtTextArea *txt;
	
	tcd=(GtToggleCD *)cd;
	txt=(GtTextArea *)ud;
	txt->SetAttr(tcd->on ? txt->GetAttr()|GTTA_BOLD : txt->GetAttr()&~GTTA_BOLD);
	return(GTCB_CONT);
}

int AttrULineCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	GtToggleCD *tcd;
	GtTextArea *txt;
	
	tcd=(GtToggleCD *)cd;
	txt=(GtTextArea *)ud;
	txt->SetAttr(tcd->on ? txt->GetAttr()|GTTA_UNDERLINE : txt->GetAttr()&~GTTA_UNDERLINE);
	return(GTCB_CONT);
}

int AttrRevCB(GtBase *obj,GtCDPtr cd,GtUDPtr ud)
{
	GtToggleCD *tcd;
	GtTextArea *txt;
	
	tcd=(GtToggleCD *)cd;
	txt=(GtTextArea *)ud;
	txt->SetAttr(tcd->on ? txt->GetAttr()|GTTA_REVERSE : txt->GetAttr()&~GTTA_REVERSE);
	return(GTCB_CONT);
}

int main(int argc,char **argv)
{
	GtApp *app;
	GtAppDisp *dsp;
	GtAppShell *shell;
	GtGroup *g,*g2;
	GtRadioGroup *rg;
	GtToggle *t;
	GtStrInput *str;
	GtTextArea *txt;
	
	app=GtMkApp(NULL);
	app->SetupRes(&argc,argv);
	dsp=GtMkAppDisp(app,NULL);
	shell=GtMkAppShell("shell",(GtManager *)dsp,
		GT_DONE);
	shell->AddCB(GT_Close,QuitCB,app);
	g2=GtMkGroup("grp2",shell,GT_Orient,GTO_HORIZ,GT_BAll,2,GT_DONE);
	g=GtMkGroup("grp",g2,GT_Orient,GTO_VERT,GT_BAll,2,GT_DONE);
	str=GtMkStrInput("str",g,GT_Weight,0,GT_DONE);
	txt=GtMkTextArea("txt",g,
		GT_Columns,40,
		GT_Rows,20,
		GT_DONE);
	str->AddCB(GT_Done,DoneCB,txt);
	g=GtMkGroup("tgrp",g2,
		GT_Orient,GTO_VERT,
		GT_BAll,2,
		GT_Weight,0,
		GT_Place,GTP_TOPLEFT,
		GT_DONE);
	t=GtMkToggle("t1",g,NULL);
	GtMkLabel("bold",t,NULL);
	t->AddCB(GT_Activate,AttrBoldCB,txt);
	t=GtMkToggle("t2",g,NULL);
	GtMkLabel("underline",t,NULL);
	t->AddCB(GT_Activate,AttrULineCB,txt);
	t=GtMkToggle("t3",g,NULL);
	GtMkLabel("reverse",t,NULL);
	t->AddCB(GT_Activate,AttrRevCB,txt);
	shell->Build();
	app->EventLoop(GTAM_LOOP);
	GtDestroy(app);
}
